<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>The ASG</title><link rel="stylesheet" href="synopsis.css" type="text/css" /><meta name="generator" content="DocBook XSL Stylesheets V1.73.2" /><link rel="start" href="index.html" title="Synopsis Tutorial" /><link rel="up" href="scripting.html" title="Chapter 3. Scripting And Extending Synopsis" /><link rel="prev" href="scripting.html" title="Chapter 3. Scripting And Extending Synopsis" /><link rel="next" href="processor.html" title="The Processor class" /></head><body><div class="navheader"><table width="100%" summary="Navigation header"><tr><th colspan="3" align="center">The ASG</th></tr><tr><td width="20%" align="left"><a accesskey="p" href="scripting.html">Prev</a> </td><th width="60%" align="center">Chapter 3. Scripting And Extending Synopsis</th><td width="20%" align="right"> <a accesskey="n" href="processor.html">Next</a></td></tr></table></div><div class="section" lang="en" xml:lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a id="asg"></a>The ASG</h2></div></div></div><p>At the core of synopsis is a representation of
        the source code to be analyzed called an Abstract Semantic
        Graph (ASG). Language-specific syntax gets translated into
        an abstract graph of statements, annotated with all the necessary
        metadata to recover the important details during further processing.</p><p>At this time only one particular type of statements is translated
        into an ASG: declarations. This can be declarations of types, functions,
        variables, etc. Attached to a declaration is a set of comments that was
        found in the source code before the declaration. It is thus possible
        to provide other metadata (such as code documentation) as part of these
        comments. A variety of comment processors exist to extract such metadata
        from comments.</p><div class="mediaobject"><img src="images/asg.png" width="432" /></div></div><div class="navfooter"><table width="100%" summary="Navigation footer"><tr><td width="40%" align="left"><a accesskey="p" href="scripting.html">Prev</a> </td><td width="20%" align="center"><a accesskey="u" href="scripting.html">Up</a></td><td width="40%" align="right"> <a accesskey="n" href="processor.html">Next</a></td></tr><tr><td width="40%" align="left" valign="top">Chapter 3. Scripting And Extending Synopsis </td><td width="20%" align="center"><a accesskey="h" href="index.html">Home</a></td><td width="40%" align="right" valign="top"> The Processor class</td></tr></table></div></body></html>
